unit listplug; { Contents of file listplug.pas }

interface

uses
  windows, SysUtils, Dialogs,Globals;

const
  lc_copy=1;
  lc_newparams=2;
  lc_selectall=3;
  lc_setpercent=4;

  lcp_wraptext=1;
  lcp_fittowindow=2;
  lcp_ansi=4;
  lcp_ascii=8;
  lcp_variable=12;
  lcp_forceshow=16;

  lcs_findfirst=1;
  lcs_matchcase=2;
  lcs_wholewords=4;
  lcs_backwards=8;

  itm_percent=$FFFE;
  itm_fontstyle=$FFFD;
  itm_wrap=$FFFC;
  itm_fit=$FFFB;

  LISTPLUGIN_OK=0;
  LISTPLUGIN_ERROR=1;

  MAX_PATH=32000;

type
  tListDefaultParamStruct=record
    size,
    PluginInterfaceVersionLow,
    PluginInterfaceVersionHi:longint;
    DefaultIniName: array[0..MAX_PATH-1] of AnsiChar;
  end;
  pListDefaultParamStruct=^tListDefaultParamStruct;

{ Function prototypes: Functions need to be defined exactly like this!}


function ListLoad(ParentWin:thandle;FileToLoad:PAnsiChar;ShowFlags:integer):thandle; stdcall;
function ListLoadW(ParentWin:thandle;FileToLoad:PWideChar;ShowFlags:integer):thandle; stdcall;
procedure ListCloseWindow(ListWin:thandle); stdcall;
procedure ListGetDetectString(DetectString:PAnsiChar;maxlen:integer); stdcall;
function ListSearchText(ListWin:thandle;SearchString:PAnsiChar;
                        SearchParameter:integer):integer; stdcall;
function ListSendCommand(ListWin:thandle;Command,Parameter:integer):integer; stdcall;
function ListPrint(ListWin:thandle;FileToPrint,DefPrinter:PAnsiChar;
                   PrintFlags:integer;var Margins:trect):integer; stdcall;
function ListNotificationReceived(ListWin:thandle;Message,wParam,lParam:integer):integer; stdcall;
procedure ListSetDefaultParams(dps:pListDefaultParamStruct); stdcall;

implementation

uses
  GridForm, Controls;

function ListLoadW(ParentWin:thandle;FileToLoad:PWideChar;ShowFlags:integer):thandle; stdcall;
begin
  if (UpperCase(ExtractFileExt(FileToLoad)) <> UpperCase('.pdb'))
      and (UpperCase(ExtractFileExt(FileToLoad)) <>  UpperCase('.prc')) then
  begin
    Result := 0;
    Exit;
  end;

  Result := CreateGrid(ParentWin, FileToLoad);
end;

function ListLoad(ParentWin:thandle;FileToLoad:PAnsiChar;ShowFlags:integer):thandle; stdcall;
begin
  Result := ListLoadW(ParentWin, PChar(WideString(FileToLoad)), ShowFlags);
end;

procedure ListCloseWindow(ListWin:thandle); stdcall;
begin
  FreeGrid(ListWin);
end;
//copy from Ghisler's filesys.cpp
procedure _strcpy(p, p2: PAnsiChar; MaxLen: integer);
begin
  if lstrlenA(p2)>=MaxLen
    then
      begin
      lstrcpynA(p, p2, MaxLen);
      p[MaxLen]:= #0;
      end
    else
      lstrcpyA(p, p2);
end;

procedure ListGetDetectString(DetectString:PAnsiChar;maxlen:integer); stdcall;
begin
//  DetectString := 'EXT="PDB" | EXT="PRC"';
//EXT="PDB" | EXT="PRC"
// DetectString := 'EXT="PDB" | EXT="PRC"';
 _strcpy(DetectString, _DetectString, MaxLen);
end;

function ListSearchText(ListWin:thandle;SearchString:PAnsiChar;
                        SearchParameter:integer):integer; stdcall;
begin
  Result :=SearchText(ListWin,SearchString,SearchParameter);
end;

function ListSendCommand(ListWin:thandle;Command,Parameter:integer):integer; stdcall;
begin
end;

function ListPrint(ListWin:thandle;FileToPrint,DefPrinter:PAnsiChar;
                   PrintFlags:integer;var Margins:trect):integer; stdcall;
begin
end;

function ListNotificationReceived(ListWin:thandle;Message,wParam,lParam:integer):integer; stdcall;
begin
end;

procedure ListSetDefaultParams(dps:pListDefaultParamStruct); stdcall;
begin
end;
end.

